import math,random
def simpleMap(damax,dbmax,dwmax,\
		adiff,bdiff,wdiff,\
		amax=math.pi*2,bmax=math.pi/4-math.pi/8,wmax=math.pi/8,\
		amin=-math.pi*2,bmin=0,wmin=math.pi/32\
		):
	aoff=math.pi/2.
	boff=math.pi/2
	woff=0.
	a=aoff
	b=boff
	w=(wmax+wmin)/2
	da=0
	db=0
	dw=0
	for n in xrange(100):
		yield (a,b,w)
	while True:
		da+=adiff*random.random()*2-adiff
		db+=bdiff*random.random()*2-bdiff
		dw+=wdiff*random.random()*2-wdiff
		if da>damax:da=damax
		elif da<-damax:da=-damax
		if dw>dwmax:dw=dwmax
		elif dw<-dwmax:dw=-dwmax
		if db>dbmax:db=dbmax
		elif db<-dbmax:db=-dbmax
		#print da,a,amax,amin
		a+=da
		b+=db
		w+=dw
		if (a-aoff)>amax:a=amax+aoff
		elif (a-aoff)<amin:a=amin+aoff
		if (b-boff)>bmax:
			b=bmax+boff
			db=-db
		elif (b-boff)<bmin:
			b=bmin+boff
			db=-db
		if (w-woff)>wmax:
			#print "wmax"
			w=wmax+woff
			dw=-dw
		elif (w-woff)<wmin:
			#print "wmin"			
			w=wmin+woff
			dw=-dw			
		#print w-woff,">",wmax
		#print w-woff,"<",wmin		
		#ar=int(a/(math.pi*2))
		#br=int(b/(math.pi*2))
		#wr=int(w/(math.pi*2))
		#if ar:
		#	a-=ar*(math.pi*2)
		#if br:
		#	b-=br*(math.pi2)
		#if wr:
		#	w-=wr*(math.pi*2)
		yield (a,b,w)
def makePoint(angle,size=0.7):
	return (math.cos(angle)*size,math.sin(angle)*size)
def abw2points((a,b,w),size=1):
	p=makePoint

	return [p(a+b+w),p(a+b+w,1),p(a+b,1),p(a+b-w,1),p(a+b-w),p(a+(b-w)/2.),p(a),p(a-(b-w)/2.),p(a-(b-w)),p(a-(b-w),1),p(a-b,1),p(a-(b+w),1),p(a-(b+w)),p(a-math.pi/2.-(w+b)/2.),p(a-math.pi),p(a+math.pi/2.+(w+b)/2)]

class Sector:
	def __init__(self,(a,b,w)):
		self.abw=(a,b,w)
		self.a,self.b,self.w=(a,b,w)
		self.points=abw2points(self.abw)
