from OpenGL.GL import *
from pygame import *
import map
font.init()
f=font.Font(None,18)
def frange(start,stop,step):
	while (start<stop and step>0) or (start<stop and step<0) :
		yield start
		start+=step
def drawSectors(listOfSectors,offset=0,step=0.5):
	coldiv=step/len(listOfSectors)
	"""
	glBegin(GL_QUADS)
	glVertex3d(-1,-1,-1)
	glVertex3d(-1,1,-1)
	glVertex3d(1,1,1)
	glVertex3d(1,-1,1)
	glEnd()
	"""
	"""
	glBegin(GL_QUAD_STRIP)
	#for p1,p2 in [((-.5,-0.5,n/100.),(-.5,0.5,n/100.)) for n in range(100)]:
	for p1,p2 in [((n/100.,-.25,-1),(n/100.,0.25,-1)) for n in range(500)]:
		glVertex3dv(p1)
		glVertex3dv(p2)
	glEnd()
	"""
	col=coldiv*offset/step
	for start,stop,z1 in zip(listOfSectors[:-1],listOfSectors[1:],frange(offset,len(listOfSectors)*step+offset,step)):
		z2=z1+step
		col+=coldiv
		#print col
		nlen=len(stop.points+stop.points[0:1])
		glBegin(GL_QUAD_STRIP)		
		for (x1,y1),(x2,y2),n in zip(start.points+start.points[0:1],stop.points+stop.points[0:1],range(nlen)):
			if 0<n<4 or nlen/2<n<nlen/2+4 :
				glColor3d(0,1-col,col/2)
			else:
				glColor3d(1-col,0,col/2)
				#glColor3d(1-col,1-col,1-col)
			glVertex3d(x1,y1,-z1)
			if 0<n<4 or nlen/2<n<nlen/2+4 :
				glColor3d(0,1-(col+coldiv),col/2)
			else:
				glColor3d(1-(col+coldiv),0,col/2+.5)
				#glColor3d(1-(col-coldiv),1-(col-coldiv),1-(col-coldiv))
			glVertex3d(x2,y2,-z2)
		glEnd()
		"""
		glColor3d(0,0,1-col)
		glBegin(GL_LINES)		
		for (x1,y1),(x2,y2) in zip(start.points+start.points[0:1],stop.points+stop.points[0:1]):
			glVertex3d(x2,y2,-z2)			
			glVertex3d(x1,y1,-z1)
		glEnd()
			
		glBegin(GL_LINE_LOOP)
		for (x1,y1) in start.points:
			glVertex3d(x1,y1,-z1)
			
		glEnd()
		"""
def drawPlayer(a,b,c=(1,1,1),size=1):
	p=map.makePoint
	glPointSize(size)
	glBegin(GL_POINTS)
	glColor3dv(c)
	glVertex3dv(p(a-b)+(-5,))
	glVertex3dv(p(a+b)+(-5,))
	glEnd()
	glLineWidth(size)
	glBegin(GL_LINES)
	glVertex3dv((0,0,0))
	glVertex3dv(p(a)+(-5,))
	glEnd()
text={}
def drawText(string,x,y,save=False):
	w=h=texture=None
	if string not in text:
		t=f.render(string,True,(1,1,1,1),(0,0,0,0))
		s=image.tostring(t,"RGBA",True)
		w,h=t.get_width(),t.get_height()
		texture=glGenTextures(1)
		glBindTexture(GL_TEXTURE_2D, texture)
    		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
    		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
    		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA,GL_UNSIGNED_BYTE,s)
		if save:text[string]=(texture,w,h)
	else:
		texture,w,h=text[string]
	glBindTexture(GL_TEXTURE_2D, texture)
    	glBegin(GL_QUADS)
 
    	# Bottom Right Of The Texture and Quad
    	glTexCoord2f(1, 0); glVertex3f(w+x,y,-5)

    	# Top Right Of The Texture and Quad
    	glTexCoord2f(1, 1); glVertex3f(w+x,h+y,-5)

    	# Top Left Of The Texture and Quad
    	glTexCoord2f(0, 1); glVertex3f(x, h+y,-5)

	# Bottom Left Of The Texture and Quad
    	glTexCoord2f(0, 0); glVertex3f(x, y,-5)

    	glEnd()
	if not save:glDeleteTextures(texture)
	
	
	
	
				
